package com.jarvis.dataCenter.entity.jws;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;


import lombok.Data;

import com.jarvis.lib.common.mybatisplus.entity.AbstractEntity;
/**
 * <p>
 * 产品证照信息表 ENTITY
 * </p>
 *
 * @author jinzhaopo
 * @since 2019-11-06
 */
@Data
@TableName("t_licence")
public class TLicenceEntity extends AbstractEntity {

    private static final long serialVersionUID = 1L;
    
    @TableId(value = ID, type = IdType.AUTO)
    private Integer id;
    
    /**
     * 证照编号
     */
    @TableField(LICENCECODE)
    private String licenceCode;
    
    /**
     * 产品证照类型，bus_product_apparatustype，itemGpCode=bus_licenceType
     */
    @TableField(LICENCETYPEID)
    private Integer licenceTypeId;
    
    /**
     * 注册人名称
     */
    @TableField(REGPERSON)
    private String regperson;
    
    /**
     * 产品名称
     */
    @TableField(PRODUCTNAME)
    private String productName;
    
    /**
     * 商品产地
     */
    @TableField(PRODUCTORIGIN)
    private String productOrigin;
    
    /**
     * 产品规范
     */
    @TableField(PRODUCTSPEC)
    private String productSpec;
    
    /**
     * 生效日期
     */
    @TableField(BEGINDATE)
    private Date beginDate;
    
    /**
     * 到期日期
     */
    @TableField(ENDDATE)
    private Date endDate;
    
    /**
     * 备注信息
     */
    @TableField(REMARK)
    private String remark;
    
    /**
     * 附件id（关联t_resource表的id）
     */
    @TableField(RESOURCEID)
    private Long resourceId;
    
    /**
     * 状态 0：失效 1：有效
     */
    @TableField(STATUS)
    private Integer status;
    
    /**
     * 创建人
     */
    @TableField(CREATOR)
    private String creator;
    
    /**
     * 修改人
     */
    @TableField(MODIFIER)
    private String modifier;
    
    /**
     * 创建时间
     */
    @TableField(CREATEDTIME)
    private Date createdTime;
    
    /**
     * 更新时间
     */
    @TableField(MODIFIEDTIME)
    private Date modifiedTime;
    
    /**
     * 是否长期有效(0：否1：是)
     */
    @TableField(ISETERNAL)
    private Integer isEternal;



    /**
     * 
     */
    public static final String ID = "id";

    /**
     * 证照编号
     */
    public static final String LICENCECODE = "licenceCode";

    /**
     * 产品证照类型，bus_product_apparatustype，itemGpCode=bus_licenceType
     */
    public static final String LICENCETYPEID = "licenceTypeId";

    /**
     * 注册人名称
     */
    public static final String REGPERSON = "regperson";

    /**
     * 产品名称
     */
    public static final String PRODUCTNAME = "productName";

    /**
     * 商品产地
     */
    public static final String PRODUCTORIGIN = "productOrigin";

    /**
     * 产品规范
     */
    public static final String PRODUCTSPEC = "productSpec";

    /**
     * 生效日期
     */
    public static final String BEGINDATE = "beginDate";

    /**
     * 到期日期
     */
    public static final String ENDDATE = "endDate";

    /**
     * 备注信息
     */
    public static final String REMARK = "remark";

    /**
     * 附件id（关联t_resource表的id）
     */
    public static final String RESOURCEID = "resourceId";

    /**
     * 状态 0：失效 1：有效
     */
    public static final String STATUS = "status";

    /**
     * 创建人
     */
    public static final String CREATOR = "creator";

    /**
     * 修改人
     */
    public static final String MODIFIER = "modifier";

    /**
     * 创建时间
     */
    public static final String CREATEDTIME = "createdTime";

    /**
     * 更新时间
     */
    public static final String MODIFIEDTIME = "modifiedTime";

    /**
     * 是否长期有效(0：否1：是)
     */
    public static final String ISETERNAL = "isEternal";


}
