package com.jarvis.dataCenter.entity.jws;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;


import lombok.Data;

import com.jarvis.lib.common.mybatisplus.entity.AbstractEntity;
/**
 * <p>
 *  ENTITY
 * </p>
 *
 * @author jinzhaopo
 * @since 2019-11-06
 */
@Data
@TableName("t_product")
public class TProductEntity extends AbstractEntity {

    private static final long serialVersionUID = 1L;
    
    /**
     * 主键 产品ID 自增长
     */
    @TableId(value = ID, type = IdType.AUTO)
    private Integer id;
    
    /**
     * 产品品牌ID
     */
    @TableField(BRANDID)
    private Integer brandId;
    
    /**
     * 一级分类id
     */
    @TableField(CATEGORYID)
    private Integer categoryId;
    
    /**
     * 二级分类id
     */
    @TableField(SUBCATEGORYID)
    private Integer subcategoryId;
    
    /**
     * 三级分类id
     */
    @TableField(DETAILCATEGORYID)
    private Integer detailcategoryId;
    
    /**
     * 一级展示分类id
     */
    @TableField(SHOWCATEGORYID)
    private Integer showCategoryId;
    
    /**
     * 二级展示分类id
     */
    @TableField(SHOWSUBCATEGORYID)
    private Integer showSubcategoryId;
    
    /**
     * 三级展示分类id
     */
    @TableField(SHOWDETAILCATEGORYID)
    private Integer showDetailcategoryId;
    
    /**
     * 生产厂商id，关联供应商主表
     */
    @TableField(PRODUCERID)
    private Integer producerId;
    
    /**
     * 预留：平台产品编码
     */
    @TableField(PRODUCTCODE)
    private String productCode;
    
    /**
     * 预留：厂商内部编码
     */
    @TableField(INSIDECODEPRO)
    private String insideCodePro;
    
    /**
     * 预留：代理商用货号
     */
    @TableField(INSIDECODEDIS)
    private String insideCodeDis;
    
    /**
     * 预留：供应商内部一级分类
     */
    @TableField(PRODUCERCATEGORY)
    private String producerCategory;
    
    /**
     * 预留：供应商内部二级分类
     */
    @TableField(PRODUCERSUBCATEGORY)
    private String producerSubcategory;
    
    /**
     * 预留：供应商内部三级分类
     */
    @TableField(PRODUCERDETAILCATEGORY)
    private String producerDetailcategory;
    
    /**
     * 器械类别，bus_product_apparatustype,itemGpCode=bus_product_apparatustype
     */
    @TableField(APPARATUSTYPE)
    private String apparatustype;
    
    /**
     * 产品中文名称
     */
    @TableField(PRODUCTNAMECN)
    private String productNameCn;
    
    /**
     * 产品英文名称
     */
    @TableField(PRODUCTNAMEEN)
    private String productNameEn;
    
    /**
     * 产品俗名
     */
    @TableField(PRODUCTPOPULARNAME)
    private String productpopularName;
    
    /**
     * 产品系列中文
     */
    @TableField(PRODUCTSERIESNAMECN)
    private String productSeriesNameCn;
    
    /**
     * 产品系列英文
     */
    @TableField(PRODUCTSERIESNAMEEN)
    private String productSeriesNameEn;
    
    /**
     * 产地
     */
    @TableField(ORIGIN)
    private String origin;
    
    /**
     * 原产地
     */
    @TableField(ORIGINCOUNTRY)
    private String originCountry;
    
    /**
     * 产品中文描述
     */
    @TableField(PRODUCTDESCCN)
    private String productDescCn;
    
    /**
     * 产品英文描述
     */
    @TableField(PRODUCTDESCEN)
    private String productDescEn;
    
    /**
     * 适用范围
     */
    @TableField(APPSCOPE)
    private String appScope;
    
    /**
     * 预留1
     */
    @TableField(TAX_NUMBER)
    private String taxNumber;
    
    /**
     * 商城首页排序
     */
    @TableField(RESERVEII)
    private Integer reserveii;
    
    /**
     * 预留3
     */
    @TableField(RESERVEIII)
    private String reserveiii;
    
    /**
     * 预留4
     */
    @TableField(RESERVEIV)
    private String reserveiv;
    
    /**
     * 预留5
     */
    @TableField(RESERVEV)
    private String reservev;
    
    /**
     * 预留6
     */
    @TableField(RESERVEVI)
    private String reservevi;
    
    /**
     * 审核状态：0：创建，1：待审核，2：已审核，3：驳回，4：关闭
     */
    @TableField(APPSTATUS)
    private Boolean appStatus;
    
    /**
     * 使用说明
     */
    @TableField(INSTRUCTION)
    private String instruction;
    
    /**
     * 序号：显示排序 商城显示排序
     */
    @TableField(ROWNUM)
    private Integer rownum;
    
    /**
     * 状态 0：禁用 1：启用
     */
    @TableField(USEFLG)
    private Boolean useFlg;
    
    /**
     * 备注
     */
    @TableField(MEMO)
    private String memo;
    
    /**
     * 创建人
     */
    @TableField(CREATOR)
    private String creator;
    
    /**
     * 修改人
     */
    @TableField(EDITOR)
    private String editor;
    
    /**
     * 创建时间
     */
    @TableField(CREATEDTIME)
    private Date createdTime;
    
    /**
     * 更新时间
     */
    @TableField(UPDATEDTIME)
    private Date updatedTime;
    
    /**
     * 内部商品 0开放 1 内部可见
     */
    @TableField(INSIDEGOODS)
    private Boolean insideGoods;
    
    /**
     * 货品分类--》com_system->so_goodsType
     */
    @TableField(GOODSTYPE)
    private String goodsType;
    
    /**
     * 货品分类名称
     */
    @TableField(GOODSTYPENAME)
    private String goodsTypeName;
    
    /**
     * 存储条件
     */
    @TableField(STORAGECONDITION)
    private Boolean storageCondition;



    /**
     * 主键 产品ID 自增长
     */
    public static final String ID = "id";

    /**
     * 产品品牌ID
     */
    public static final String BRANDID = "brandId";

    /**
     * 一级分类id
     */
    public static final String CATEGORYID = "categoryId";

    /**
     * 二级分类id
     */
    public static final String SUBCATEGORYID = "subcategoryId";

    /**
     * 三级分类id
     */
    public static final String DETAILCATEGORYID = "detailcategoryId";

    /**
     * 一级展示分类id
     */
    public static final String SHOWCATEGORYID = "showCategoryId";

    /**
     * 二级展示分类id
     */
    public static final String SHOWSUBCATEGORYID = "showSubcategoryId";

    /**
     * 三级展示分类id
     */
    public static final String SHOWDETAILCATEGORYID = "showDetailcategoryId";

    /**
     * 生产厂商id，关联供应商主表
     */
    public static final String PRODUCERID = "producerId";

    /**
     * 预留：平台产品编码
     */
    public static final String PRODUCTCODE = "productCode";

    /**
     * 预留：厂商内部编码
     */
    public static final String INSIDECODEPRO = "insideCodePro";

    /**
     * 预留：代理商用货号
     */
    public static final String INSIDECODEDIS = "insideCodeDis";

    /**
     * 预留：供应商内部一级分类
     */
    public static final String PRODUCERCATEGORY = "producerCategory";

    /**
     * 预留：供应商内部二级分类
     */
    public static final String PRODUCERSUBCATEGORY = "producerSubcategory";

    /**
     * 预留：供应商内部三级分类
     */
    public static final String PRODUCERDETAILCATEGORY = "producerDetailcategory";

    /**
     * 器械类别，bus_product_apparatustype,itemGpCode=bus_product_apparatustype
     */
    public static final String APPARATUSTYPE = "apparatustype";

    /**
     * 产品中文名称
     */
    public static final String PRODUCTNAMECN = "productNameCn";

    /**
     * 产品英文名称
     */
    public static final String PRODUCTNAMEEN = "productNameEn";

    /**
     * 产品俗名
     */
    public static final String PRODUCTPOPULARNAME = "productpopularName";

    /**
     * 产品系列中文
     */
    public static final String PRODUCTSERIESNAMECN = "productSeriesNameCn";

    /**
     * 产品系列英文
     */
    public static final String PRODUCTSERIESNAMEEN = "productSeriesNameEn";

    /**
     * 产地
     */
    public static final String ORIGIN = "origin";

    /**
     * 原产地
     */
    public static final String ORIGINCOUNTRY = "originCountry";

    /**
     * 产品中文描述
     */
    public static final String PRODUCTDESCCN = "productDescCn";

    /**
     * 产品英文描述
     */
    public static final String PRODUCTDESCEN = "productDescEn";

    /**
     * 适用范围
     */
    public static final String APPSCOPE = "appScope";

    /**
     * 预留1
     */
    public static final String TAX_NUMBER = "tax_number";

    /**
     * 商城首页排序
     */
    public static final String RESERVEII = "reserveii";

    /**
     * 预留3
     */
    public static final String RESERVEIII = "reserveiii";

    /**
     * 预留4
     */
    public static final String RESERVEIV = "reserveiv";

    /**
     * 预留5
     */
    public static final String RESERVEV = "reservev";

    /**
     * 预留6
     */
    public static final String RESERVEVI = "reservevi";

    /**
     * 审核状态：0：创建，1：待审核，2：已审核，3：驳回，4：关闭
     */
    public static final String APPSTATUS = "appStatus";

    /**
     * 使用说明
     */
    public static final String INSTRUCTION = "instruction";

    /**
     * 序号：显示排序 商城显示排序
     */
    public static final String ROWNUM = "rownum";

    /**
     * 状态 0：禁用 1：启用
     */
    public static final String USEFLG = "useFlg";

    /**
     * 备注
     */
    public static final String MEMO = "memo";

    /**
     * 创建人
     */
    public static final String CREATOR = "creator";

    /**
     * 修改人
     */
    public static final String EDITOR = "editor";

    /**
     * 创建时间
     */
    public static final String CREATEDTIME = "createdTime";

    /**
     * 更新时间
     */
    public static final String UPDATEDTIME = "updatedTime";

    /**
     * 内部商品 0开放 1 内部可见
     */
    public static final String INSIDEGOODS = "insideGoods";

    /**
     * 货品分类--》com_system->so_goodsType
     */
    public static final String GOODSTYPE = "goodsType";

    /**
     * 货品分类名称
     */
    public static final String GOODSTYPENAME = "goodsTypeName";

    /**
     * 存储条件
     */
    public static final String STORAGECONDITION = "storageCondition";


}
