package com.jarvis.dataCenter.entity.jws;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;


import lombok.Data;

import com.jarvis.lib.common.mybatisplus.entity.AbstractEntity;
/**
 * <p>
 * 产品证照关系表 ENTITY
 * </p>
 *
 * @author jinzhaopo
 * @since 2019-11-06
 */
@Data
@TableName("t_product_licence")
public class TProductLicenceEntity extends AbstractEntity {

    private static final long serialVersionUID = 1L;
    
    @TableId(value = ID, type = IdType.AUTO)
    private Integer id;
    
    /**
     * 产品id
     */
    @TableField(PRODUCTID)
    private Integer productId;
    
    /**
     * 证照id
     */
    @TableField(LICENCEID)
    private Integer licenceId;
    
    /**
     * 是否主试剂证件 0-否  1-是
     */
    @TableField(MAJORSTATUS)
    private String majorStatus;
    
    /**
     * 状态：0-失效 1- 有效
     */
    @TableField(STATUS)
    private String status;
    
    /**
     * 创建人
     */
    @TableField(CREATOR)
    private String creator;
    
    /**
     * 修改人
     */
    @TableField(MODIFIER)
    private String modifier;
    
    /**
     * 创建时间
     */
    @TableField(CREATEDTIME)
    private Date createdTime;
    
    /**
     * 修改时间
     */
    @TableField(MODIFIEDTIME)
    private Date modifiedTime;



    /**
     * 
     */
    public static final String ID = "id";

    /**
     * 产品id
     */
    public static final String PRODUCTID = "productId";

    /**
     * 证照id
     */
    public static final String LICENCEID = "licenceId";

    /**
     * 是否主试剂证件 0-否  1-是
     */
    public static final String MAJORSTATUS = "majorStatus";

    /**
     * 状态：0-失效 1- 有效
     */
    public static final String STATUS = "status";

    /**
     * 创建人
     */
    public static final String CREATOR = "creator";

    /**
     * 修改人
     */
    public static final String MODIFIER = "modifier";

    /**
     * 创建时间
     */
    public static final String CREATEDTIME = "createdTime";

    /**
     * 修改时间
     */
    public static final String MODIFIEDTIME = "modifiedTime";


}
