package com.jarvis.dataCenter.entity.report;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jarvis.lib.common.mybatisplus.entity.AbstractEntity;
import lombok.Data;

import java.util.Date;

/**
 * 证照关联表 证照和产品的中间表
 *
 * @author jinzhaopo
 * @date 2019-11-06 16:30
 */
@Data
@TableName("report_t_licence_info")
public class ReportTLicenceInfo extends AbstractEntity {
    /**
     * 自增长
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    private Long productLicenceId;

    /**
     * 产品id
     */
    private Integer productId;

    /**
     * 证照id
     */
    private Integer licenceId;

    /**
     * 是否主试剂证件 0-否  1-是
     */
    private String majorStatus;


    //------t_licence
    /**
     * 证照编号
     */
    private String licenceCode;

    /**
     * 产品证照类型，bus_product_apparatustype，itemGpCode=bus_licenceType
     */
    private Integer licenceTypeId;

    /**
     * 注册人名称
     */
    private String regperson;

    /**
     * 产品名称
     */
    private String productName;

    /**
     * 商品产地
     */
    private String productOrigin;

    /**
     * 产品规范
     */
    private String productSpec;

    /**
     * 生效日期
     */
    private Date beginDate;

    /**
     * 到期日期
     */
    private Date endDate;

    /**
     * 备注信息
     */
    private String remark;

    /**
     * 附件id（关联t_resource表的id）
     */
    private Long resourceId;

    /**
     * 状态 0：失效 1：有效
     */
    private Integer status;

    /**
     * 创建人
     */
    private String creator;

    /**
     * 修改人
     */
    private String modifier;

    /**
     * 创建时间
     */
    private Date createdTime;

    /**
     * 更新时间
     */
    private Date modifiedTime;

    /**
     * 是否长期有效(0：否1：是)
     */
    private Integer isEternal;


}
