package com.jarvis.dataCenter.entity.warehouse;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jarvis.lib.common.mybatisplus.entity.AbstractEntity;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 库位表 ENTITY
 * </p>
 *
 * @author jinzhaopo
 * @since 2019-11-05
 */
@Data
@TableName("stock_container")
public class StockContainerEntity extends AbstractEntity {

    private static final long serialVersionUID = 1L;

    @TableId(value = ID, type = IdType.AUTO)
    private Long id;

    /**
     * 仓库id
     */
    @TableField(WAREHOUSE_ID)
    private Long warehouseId;

    /**
     * 名称
     */
    @TableField(NAME)
    private String name;

    /**
     * 编号
     */
    @TableField(CODE)
    private String code;

    /**
     * 容器类型
     */
    @TableField(CONTAINER_TYPE)
    private String containerType;

    /**
     * 容量
     */
    @TableField(CAPACITY)
    private Integer capacity;

    /**
     * 是否启用
     */
    @TableField(ENABLED)
    private String enabled;

    @TableField(CREATED_TIME)
    private Date createdTime;

    @TableField(UPDATED_TIME)
    private Date updatedTime;

    @TableField(VERSION)
    private Integer version;


    /**
     *
     */
    public static final String ID = "id";

    /**
     * 仓库id
     */
    public static final String WAREHOUSE_ID = "warehouse_id";

    /**
     * 名称
     */
    public static final String NAME = "name";

    /**
     * 编号
     */
    public static final String CODE = "code";

    /**
     * 容器类型
     */
    public static final String CONTAINER_TYPE = "container_type";

    /**
     * 容量
     */
    public static final String CAPACITY = "capacity";

    /**
     * 是否启用
     */
    public static final String ENABLED = "enabled";

    /**
     *
     */
    public static final String CREATED_TIME = "created_time";

    /**
     *
     */
    public static final String UPDATED_TIME = "updated_time";

    /**
     *
     */
    public static final String VERSION = "version";


}
