package com.jarvis.dataCenter.service.impl.report;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.jarvis.common.redis.service.RedisService;
import com.jarvis.dataCenter.bean.BeanUtils;
import com.jarvis.dataCenter.constants.DbConstants;
import com.jarvis.dataCenter.entity.prod.BusAgencymasterEntity;
import com.jarvis.dataCenter.entity.report.ReportAgencyInfo;
import com.jarvis.dataCenter.mapper.prod.BusAgencymasterMapper;
import com.jarvis.dataCenter.mapper.report.ReportAgencyInfoMapper;
import com.jarvis.dataCenter.service.prod.BusAgencymasterService;
import com.jarvis.dataCenter.service.report.ReportAgencyInfoService;
import com.jarvis.lib.common.mybatisplus.service.impl.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author jinzhaopo
 * @date 2019-11-01 15:10
 */
@DS(DbConstants.REPORT)
@Service
@Slf4j
public class ReportAgencyInfoServiceImpl extends BaseServiceImpl<ReportAgencyInfoMapper, ReportAgencyInfo> implements ReportAgencyInfoService {

    @Autowired
    private BusAgencymasterService busAgencymasterService;

    @Autowired
    private BusAgencymasterMapper busAgencymasterMapper;

    @Autowired
    private RedisService redisService;

    public static String REDIS_KEY = "sync:report:agency:id:";


    @Override
    public boolean sync() {
        Long endId = busAgencymasterMapper.maxId();
        Integer startId = (Integer) redisService.get(REDIS_KEY);
        if (startId == null) {
            startId = 0;
        }
        if (startId.intValue() > endId.intValue()) {
            return false;
        }

        //  同步信息
        for (long i = startId.intValue(); i <= endId.intValue(); i++) {
            try {
                sync(i);
            } catch (Exception e) {
                e.printStackTrace();
            }
            redisService.getRedisTemplateObj().opsForValue().increment(REDIS_KEY, 1);
        }

        return true;
    }

    @Override
    public ReportAgencyInfo sync(Long agencyId) {
        ReportAgencyInfo reportAgencyInfo = new ReportAgencyInfo();
        BusAgencymasterEntity busAgencymasterEntity = busAgencymasterService.getById(agencyId);
        if (busAgencymasterEntity == null) {
            return null;
        }
        BeanUtils.build(reportAgencyInfo, busAgencymasterEntity);
        save(reportAgencyInfo);

        return reportAgencyInfo;
    }
}
