package com.jarvis.dataCenter.service.impl.report;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.jarvis.common.redis.service.RedisService;
import com.jarvis.dataCenter.bean.BeanUtils;
import com.jarvis.dataCenter.constants.DbConstants;
import com.jarvis.dataCenter.entity.report.ReportDolicenceInfo;
import com.jarvis.dataCenter.entity.warehouse.DeliveryLicenceEntity;
import com.jarvis.dataCenter.mapper.report.ReportDolicenceInfoMapper;
import com.jarvis.dataCenter.mapper.warehouse.DeliveryLicenceMapper;
import com.jarvis.dataCenter.service.report.ReportDolicenceInfoService;
import com.jarvis.dataCenter.service.warehouse.DeliveryLicenceService;
import com.jarvis.lib.common.base.util.JarvisCopyUtils;
import com.jarvis.lib.common.mybatisplus.service.impl.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author jinzhaopo
 * @date 2019-11-06 14:45
 */
@DS(DbConstants.REPORT)
@Service
@Slf4j
public class ReportDolicenceInfoServiceImpl extends BaseServiceImpl<ReportDolicenceInfoMapper, ReportDolicenceInfo> implements ReportDolicenceInfoService {

    @Autowired
    private DeliveryLicenceService deliveryLicenceService;

    @Autowired
    private DeliveryLicenceMapper deliveryLicenceMapper;

    @Autowired
    private RedisService redisService;


    public static String REDIS_KEY = "sync:report:do:licence:id:";


    @Override
    public boolean sync() {
        Long endId = deliveryLicenceMapper.maxId();
        Integer startId = (Integer) redisService.get(REDIS_KEY);
        if (startId == null) {
            startId = 0;
        }
        log.info(startId+","+endId);
        if (startId.intValue() > endId.intValue()) {
            return false;
        }

        //  同步信息
        for (long i = startId.intValue(); i <= endId.intValue(); i++) {
            try {
                sync(i);
            } catch (Exception e) {
                e.printStackTrace();
            }
            redisService.getRedisTemplateObj().opsForValue().increment(REDIS_KEY, 1);
        }
        return true;
    }

    @Override
    public ReportDolicenceInfo sync(Long doLicenceId) {
        ReportDolicenceInfo reportDolicenceInfo = new ReportDolicenceInfo();
        DeliveryLicenceEntity deliveryLicenceEntity = deliveryLicenceService.getById(doLicenceId);
        if (deliveryLicenceEntity == null) {
            return null;
        }
        BeanUtils.build(reportDolicenceInfo, deliveryLicenceEntity);

        save(reportDolicenceInfo);
        return reportDolicenceInfo;
    }
}
