package com.jarvis.dataCenter.service.impl.report;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.jarvis.common.redis.service.RedisService;
import com.jarvis.dataCenter.bean.BeanUtils;
import com.jarvis.dataCenter.constants.DbConstants;
import com.jarvis.dataCenter.entity.jws.TLicenceEntity;
import com.jarvis.dataCenter.entity.jws.TProductLicenceEntity;
import com.jarvis.dataCenter.entity.report.ReportTLicenceInfo;
import com.jarvis.dataCenter.mapper.jws.TProductLicenceMapper;
import com.jarvis.dataCenter.mapper.report.ReportTLicenceInfoMapper;
import com.jarvis.dataCenter.service.jws.TLicenceService;
import com.jarvis.dataCenter.service.jws.TProductLicenceService;
import com.jarvis.dataCenter.service.report.ReportTLicenceInfoService;
import com.jarvis.lib.common.mybatisplus.service.impl.BaseServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author jinzhaopo
 * @date 2019-11-06 16:54
 */
@DS(DbConstants.REPORT)
@Service
@Slf4j
public class ReportTLicenceInfoServiceImpl extends BaseServiceImpl<ReportTLicenceInfoMapper, ReportTLicenceInfo> implements ReportTLicenceInfoService {

    @Autowired
    private TProductLicenceService tProductLicenceService;

    @Autowired
    private TProductLicenceMapper tProductLicenceMapper;

    @Autowired
    private TLicenceService tLicenceService;

    @Autowired
    private RedisService redisService;

    public static String REDIS_KEY = "sync:report:product:licence:id:";


    @Override
    public boolean sync() {
        Long endId = tProductLicenceMapper.maxId();
        Integer startId = (Integer) redisService.get(REDIS_KEY);
        if (startId == null) {
            startId = 0;
        }
        if (startId.intValue() > endId.intValue()) {
            return false;
        }

        //  同步信息
        for (long i = startId.intValue(); i <= endId.intValue(); i++) {
            try {
                sync(i);
            } catch (Exception e) {
                e.printStackTrace();
            }
            redisService.getRedisTemplateObj().opsForValue().increment(REDIS_KEY, 1);
        }

        return true;
    }

    @Override
    public ReportTLicenceInfo sync(Long tLicenceProductId) {
        ReportTLicenceInfo reportTLicenceInfo = new ReportTLicenceInfo();

        TProductLicenceEntity tProductLicenceEntity = tProductLicenceService.getById(tLicenceProductId);

        if (tProductLicenceEntity == null) {
            return null;
        }
        TLicenceEntity tLicenceEntity = tLicenceService.getById(tProductLicenceEntity.getLicenceId());
        // Long productLicenceId, Integer productId, Integer licenceId, String majorStatus,
        BeanUtils.build(reportTLicenceInfo, Long.valueOf(tProductLicenceEntity.getId()), tProductLicenceEntity.getProductId(), tProductLicenceEntity.getLicenceId(), tProductLicenceEntity.getMajorStatus(), tLicenceEntity);

        save(reportTLicenceInfo);


        return reportTLicenceInfo;
    }
}
