package com.jarvis.dataCenter.service.impl.report;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.jarvis.dataCenter.constants.DbConstants;
import com.jarvis.dataCenter.service.report.*;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.concurrent.TimeUnit;

/**
 * @author jinzhaopo
 * @date 2019-11-01 14:51
 */
@DS(DbConstants.REPORT)
@Service
@Slf4j
@Data
public class ThreadServiceImpl implements ThreadService {

    public static boolean syncSku = true;
    public static boolean syncAgency = true;
    public static boolean syncAddress = true;
    public static boolean syncSoInfo = true;
    public static boolean syncCsInfo = true;
    public static boolean sycnDoInfo = true;
    public static boolean syncInvoiceInfo = true;
    public static boolean syncDoLicenceInfo = true;
    public static boolean syncProductLicenceInfo = true;


    public static long sleepSku = 10;
    public static long sleepAgency = 10;
    public static long sleepAddress = 10;
    public static long sleepSoInfo = 10;
    public static long sleepCsInfo = 10;
    public static long sleepDoInfo = 10;
    public static long sleepInvoiceInfo = 10;
    public static long sleepDoILicenceInfo = 10;
    public static long sleepProductLicenceInfo = 10;


    @Autowired
    private ReportSkuInfoService reportSkuInfoService;

    @Autowired
    private ReportAgencyInfoService reportAgencyInfoService;

    @Autowired
    private ReportAddressInfoService reportAddressInfoService;

    @Autowired
    private ReportSoPoInfoService reportSoPoInfoService;

    @Autowired
    private ReportDoInfoService reportDoInfoService;

    @Autowired
    private ReportCsOrderInfoService reportCsOrderInfoService;

    @Autowired
    private ReportInvoiceInfoService reportInvoiceInfoService;

    @Autowired
    private ReportDolicenceInfoService reportDolicenceInfoService;

    @Autowired
    private ReportTLicenceInfoService reportTLicenceInfoService;

    private Thread syncSkuThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (syncSku) {
                    boolean sync = reportSkuInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepSku);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });

    private Thread syncAgencyThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (syncAgency) {
                    boolean sync = reportAgencyInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepAgency);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });

    private Thread syncAddressThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (syncAddress) {
                    boolean sync = reportAddressInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepAddress);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });

    private Thread syncSoInfoThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (syncSoInfo) {
                    boolean sync = reportSoPoInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepSoInfo);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });

    private Thread syncCsInfoThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (syncCsInfo) {
                    boolean sync = reportCsOrderInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepCsInfo);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });

    private Thread sycnDoInfoThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (sycnDoInfo) {
                    boolean sync = reportDoInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepDoInfo);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });

    private Thread syncInvoiceInfoThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (syncInvoiceInfo) {
                    boolean sync = reportInvoiceInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepInvoiceInfo);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });

    public Thread syncDoLicenceThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (syncDoLicenceInfo) {
                    boolean sync = reportDolicenceInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepDoILicenceInfo);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });

    public Thread syncProductLicenceThread = new Thread(new Runnable() {
        @Override
        public void run() {
            while (true) {
                if (syncProductLicenceInfo) {
                    boolean sync = reportTLicenceInfoService.sync();
                    if (!sync) {
                        try {
                            TimeUnit.MINUTES.sleep(sleepProductLicenceInfo);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
    });


    @Override
    public boolean syncSku() {
        syncSkuThread.start();
        return true;
    }

    @Override
    public boolean syncAgency() {
        syncAgencyThread.start();
        return true;

    }

    @Override
    public boolean syncAddress() {
        syncAddressThread.start();
        return true;

    }

    @Override
    public boolean syncSoInfo() {
        syncSoInfoThread.start();
        return true;

    }

    @Override
    public boolean syncCsInfo() {
        syncCsInfoThread.start();
        return true;
    }

    @Override
    public boolean sycnDoInfo() {
        sycnDoInfoThread.start();
        return true;

    }

    @Override
    public boolean syncInvoiceInfo() {
        syncInvoiceInfoThread.start();
        return true;

    }

    @Override
    public boolean syncDoLicenceInfo() {
        syncDoLicenceThread.start();
        return true;
    }

    @Override
    public boolean syncProductLicenceInfo() {
        syncProductLicenceThread.start();
        return true;
    }
}
